Package: GSgalgoR
Type: Package
Title: An Evolutionary Framework for the Identification and Study of
        Prognostic Gene Expression Signatures in Cancer
Version: 1.22.0
Authors@R: c(person("Martin", "Guerrero", role = c("aut"),
                     email = "mguerrero@conicet-mendoza.gob.ar"),
              person("Carlos", "Catania", role = "cre",email="harpomaxx@gmail.com"))
Description: A multi-objective optimization algorithm for disease sub-type discovery based on a non-dominated sorting genetic algorithm. 
   The 'Galgo' framework combines the advantages of clustering algorithms for grouping heterogeneous 'omics' data and the searching properties of 
   genetic algorithms for feature selection. The algorithm search for the  optimal number of clusters determination considering the features that 
   maximize the survival difference between sub-types while keeping cluster consistency high.
License: MIT + file LICENSE
biocViews: GeneExpression, Transcription, Clustering, Classification,
        Survival
Encoding: UTF-8
Imports: cluster, doParallel, foreach, matchingR, nsga2R, survival,
        proxy, stats, methods,
Suggests: knitr, rmarkdown, ggplot2, BiocStyle, genefu, survcomp,
        Biobase, survminer, breastCancerTRANSBIG, breastCancerUPP,
        iC10TrainingData, pamr, testthat
URL: https://github.com/harpomaxx/GSgalgoR
BugReports: https://github.com/harpomaxx/GSgalgoR/issues
RoxygenNote: 7.1.0
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/GSgalgoR
git_branch: RELEASE_3_23
git_last_commit: 9bd5eb5
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:30:44 UTC; biocbuild
Author: Martin Guerrero [aut],
  Carlos Catania [cre]
Maintainer: Carlos Catania <harpomaxx@gmail.com>

#' A base callback function that returns a galgo.Obj
#' @param userdir the default directory used by `galgo()` to store files
#' @param generation a number indicating the number of iterations of the galgo 
#' algorithm
#' @param pop_pool a \code{data.frame} with the solution vectors, number of 
#' clusters and their ranking.
#' @param pareto the solutions found by Galgo across all generations in the 
#' solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#'
#' @return an object of class galgo
#' @export 
#' @usage  callback_base_return_pop (userdir = tempdir() ,generation, pop_pool, 
#' pareto, prob_matrix, current_time)
#' @examples
#' # load example dataset
#'
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo with base_return_pop_callback assigned to the end_galgo_callback
#' # hook-point
#' # By using this callback galgo() return a `galgo,Obj` object.
#' output <- GSgalgoR::galgo(generations = 5,
#' population = 15,
#' prob_matrix = expression,
#' OS = OS,
#' end_galgo_callback = callback_base_return_pop
#' )
#'
#'
callback_base_return_pop <-
    function(userdir = tempdir(),
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
        colnames(pop_pool)[seq_len(ncol(pop_pool) - 5)] <-
            rownames(prob_matrix)
        output <- list(Solutions = pop_pool, ParetoFront = pareto)
        output <-
            galgo.Obj(
                Solutions = output$Solutions,
                ParetoFront = output$ParetoFront
            )
        return(output)
    }

#' A base callback function that saves galgo.Obj
#'
#'
#'
#' @param generation a number indicating the number of iterations of the galgo 
#' algorithm
#' @param prefix a prefix used for the file name
#' @param pop_pool a \code{data.frame} with the solution vectors, number of 
#' clusters and their ranking.
#' @param pareto the solutions found by Galgo across all generations in the 
#' solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#'
#' @return an object of class galgo
#' 
#' @usage  callback_base_save_pop (userdir = tempdir(), generation, pop_pool, 
#' pareto, prob_matrix, current_time)
#'
#' @examples
#' @noRd
callback_base_save_pop <-
    function(userdir = tempdir(),
            prefix,
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
        directory <- userdir
        if (!dir.exists(directory)) {
            dir.create(directory, recursive = TRUE)
        }
        colnames(pop_pool)[seq_len(ncol(pop_pool) - 5)] <-
            rownames(prob_matrix)
        output <- list(Solutions = pop_pool, ParetoFront = pareto)
        output <-
            galgo.Obj(Solutions = output$Solutions,
                    ParetoFront = output$ParetoFront)
        filename <- file.path(directory, paste0(prefix, ".rda"))
        save(file = filename, output)
        return(output)
    }

#' A callback for saving partial galgo.Obj (every 2 generations)
#'
#' @param generation a number indicating the number of iterations of the galgo 
#' algorithm
#' @param pop_pool a \code{data.frame} with the solution vectors, number of 
#' clusters and their ranking.
#' @param pareto the solutions found by Galgo accross all generations in the 
#' solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#'
#' @return an object of class galgo
#'
#' @usage  callback_base_save_pop_partial (userdir = tempdir(), generation,
#' pop_pool, pareto, prob_matrix, current_time)
#'
#' @examples
#' @noRd
callback_base_save_pop_partial <-
    function(userdir = tempdir(),
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
        directory <- userdir
        if (!dir.exists(directory)) {
            dir.create(directory, recursive = TRUE)
        }
        if (generation %% 2 == 0) {
            callback_base_save_pop(
                userdir = directory,
                prefix = generation,
                generation,
                pop_pool,
                pareto,
                prob_matrix,
                current_time
            )
        }
    }

#' A callback for saving final galgo.Obj
#'
#' @param generation a number indicating the number of iterations of the 
#' galgo algorithm
#' @param pop_pool a \code{data.frame} with the solution vectors, number of 
#' clusters and their ranking.
#' @param pareto the solutions found by Galgo across all generations in the 
#' solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#'
#' @return
#'
#' @usage  callback_base_save_pop_final <- function(userdir = tempdir(),
#' generation, pop_pool, pareto, prob_matrix, current_time)
#'
#' @examples
#' @noRd
callback_base_save_pop_final <-
    function(userdir = tempdir(),
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
        directory <- userdir
        if (!dir.exists(directory)) {
            dir.create(directory, recursive = TRUE)
        }
        output <-
            callback_base_save_pop(
                userdir = directory,
                prefix = "final",
                generation,
                pop_pool,
                pareto,
                prob_matrix,
                current_time
            )
        message("final population saved in final.rda in ", directory)
        return(output)
    }


#' Print basic info per generation
#'
#' @param userdir the default directory used by `galgo()` to store files
#' @param generation a number indicating the number of iterations of the galgo
#'  algorithm
#' @param pop_pool a \code{data.frame} with the solution vectors, number of 
#' clusters and their ranking.
#' @param pareto the solutions found by Galgo across all generations in the 
#' solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#' @return Nothing.
#'
#' @export
#' @usage  callback_base_report (userdir = tempdir(), generation, pop_pool, 
#' pareto, prob_matrix, current_time)
#' @examples
#' # load example dataset
#'
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo with base_report_callback assigned to the report_callback
#' # hook-point
#' GSgalgoR::galgo(generations = 5,
#' population = 15,
#' prob_matrix = expression,
#' OS = OS,
#' report_callback = callback_base_report
#' )


callback_base_report <-
    function(userdir = tempdir(),
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
        chrom_length <- nrow(prob_matrix)
        message("Generation ", generation, " Non-dominated solutions:")
        print(pop_pool[pop_pool[, "rnkIndex"] == 1,
                    (chrom_length + 1):(chrom_length + 5)])
        # print(Sys.time()- start_time)
    }

#' Print minimal information to the user about galgo execution.
#'
#' The main idea behind this callback function is to provide some feedback to 
#' the user about galgo execution.
#' No other relevant information is shown
#'
#' @param userdir the default directory used by `galgo()` to store files
#' @param generation a number indicating the number of iterations of the galgo 
#' algorithm
#' @param pop_pool a \code{data.frame} with the solution vectors, number of 
#' clusters and their ranking.
#' @param pareto the solutions found by Galgo across all generations in the 
#' solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#' @return Nothing.
#'
#' @export
#' 
#' @usage  callback_no_report (userdir = tempdir(),generation, pop_pool, 
#' pareto, prob_matrix, current_time)
#' @examples
#' # load example dataset
#'
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo with no_report_callback assigned to the report_callback
#' # hook-point
#' GSgalgoR::galgo(generations = 5,
#' population = 15,
#' prob_matrix = expression,
#' OS = OS,
#' report_callback = callback_no_report
#' )
callback_no_report <-
    function(userdir = "",
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
        if (generation %% 5 == 0) {
            cat("*")
        } else {
            cat(".")
        }
    }


#' A default call_back function that does nothing.
#'
#' @param userdir the default directory used by \code{galgo()} to store files
#' @param generation a number indicating the number of iterations of the 
#' galgo algorithm
#' @param pop_pool a \code{data.frame} with the solution vectors, number 
#' of clusters and their ranking.
#' @param pareto the solutions found by Galgo across all generations in 
#' the solution space
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an 
#' expression matrix with features in rows and samples in columns
#' @param current_time an \code{POSIXct} object
#'
#'
#' @return Nothing
#' 
#' @usage  callback_default (userdir = tempdir(),generation, pop_pool, 
#' pareto, prob_matrix, current_time)
#' @export
#' @examples
#' # load example dataset
#'
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo with default_callback assigned to all the hook-points
#'
#' GSgalgoR::galgo(generations = 5,
#' population = 15,
#' prob_matrix = expression,
#' OS = OS,
#' start_galgo_callback = callback_default,# When Galgo is about to start.
#' end_galgo_callback = callback_default,  # When Galgo is about to finish.
#' start_gen_callback = callback_default,  # At the beginning of each iteration.
#' end_gen_callback = callback_default,    # At the end of each iteration.
# 'report_callback = callback_default,     # In the middle of the generation
#' )
#'
#'
callback_default <-
    function(userdir = tempdir(),
            generation,
            pop_pool,
            pareto,
            prob_matrix,
            current_time) {
    }

#' Functions to calculate distance matrices using cpu computing
#'
#' @param distancetype a \code{character} that can be either \code{'pearson'}, 
#' \code{'uncentered'}, \code{'spearman'} or \code{'euclidean'}
#' @param x an expression matrix with features as rows and samples as columns
#'
#' @return
#' \code{select_distance(distancetype)} assigns global function 
#' calculate_distance according to the parameters specified
#'
#' \code{calculate_distance_pearson_cpu(x)} returns columnwise pearson 
#' distance calculated using the CPU
#'
#' \code{calculate_distance_uncentered_cpu(x)} returns columnwise 
#' uncentered pearson distance calculated using the CPU
#'
#' \code{calculate_distance_spearman_cpu(x)} returns columnwise 
#' spearman distance calculated using the CPU
#'
#' \code{calculate_distance_euclidean_cpu(x)} returns columnwise 
#' euclidean distance calculated using the CPU
#'
#' @author Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
#' @name calculate_distance
#' @examples
#' # load example dataset
#' require(iC10TrainingData)
#' require(pamr)
#'
#' data(train.Exp)
#'
#' calculate_distance <- select_distance(distancetype = "pearson")
#' Dist <- calculate_distance(train.Exp)
#' k <- 4
#' Pam <- cluster_algorithm(Dist, k)
#' table(Pam$cluster)
NULL


#' @rdname calculate_distance
#' @export
calculate_distance_pearson_cpu <- function(x) {
    # print("pearson....")
    mx <- base::colMeans(x)
    x2 <- base::colMeans(x^2)
    mx2 <- mx^2
    sx <- sqrt(x2 - mx2)
    pDist <- ((base::crossprod(x, x) / nrow(x)) - (mx %o% mx)) / sx %o% sx
    stats::as.dist(1 - pDist)
}

#' @rdname calculate_distance
#' @export
calculate_distance_spearman_cpu <- function(x) {
    x <- apply(x, 2, rank)
    mx <- colMeans(x)
    x2 <- colMeans(x^2)
    mx2 <- mx^2
    sx <- sqrt(x2 - mx2)
    pDist <- ((crossprod(x, x) / nrow(x)) - (mx %o% mx)) / sx %o% sx
    stats::as.dist(1 - pDist)
}

#' @rdname calculate_distance
#' @export
calculate_distance_uncentered_cpu <- function(x) {
    mgpu <- t(x)
    d2 <- matrix(1, ncol = 1, nrow = dim(mgpu)[2])
    a1 <- tcrossprod(mgpu, mgpu)
    a2 <- mgpu^2 %*% d2
    pDist <- a1 / sqrt(tcrossprod(a2, a2))
    stats::as.dist(1 - pDist)
}

#' @rdname calculate_distance
#' @export
calculate_distance_euclidean_cpu <- function(x) {
    d <- stats::dist(t(x), method = "euclidean")
}

#' @rdname calculate_distance
#' @export
select_distance <- function(distancetype = "pearson") {
    distancetype <- match.arg(distancetype, c("pearson", "uncentered", 
                                                "euclidean", "spearman"))

    computingtype <- "Using CPU for computing "
    # Centered pearson distance
    if (distancetype == "pearson") {
        calculate_distance <- calculate_distance_pearson_cpu
    }
    # Spearman distance
    if (distancetype == "spearman") {
        calculate_distance <- calculate_distance_spearman_cpu
    }
    if (distancetype == "uncentered") {
        calculate_distance <- calculate_distance_uncentered_cpu
    }
        if (distancetype == "euclidean") {
            calculate_distance <- calculate_distance_euclidean_cpu
    }
    
    message(computingtype, distancetype, " distance")
    # assign("calculate_distance",calculate_distance,envir=.GlobalEnv)
    # return(invisible(calculate_distance))
    return(calculate_distance)
}

# GalgoR results functions
#' Summary of the non dominated solutions
#'
#' The function uses a \code{'galgo.Obj'} as input an the training dataset to
#' evaluate the non-dominated solutions found by GalgoR
#'
#' @param output An object of class \code{galgo.Obj}
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an
#' expression matrix with features in rows and samples in columns
#' @param OS a \code{survival} object (see \code{\link[survival]{Surv}}
#' function from the \code{\link{survival}} package)
#' @param distancetype a \code{character} that can be either \code{'pearson'},
#'  \code{'uncentered'}, \code{'spearman'} or \code{'euclidean'}
#'
#' @return Returns a \code{data.frame} with 5 columns and a number of rows
#' equals to the non-dominated solutions found by GalgoR.
#' The first column has the name of the non-dominated solutions, the second
#' the number of partitions found for each solution \code{(k)}, the third,
#' the number of genes, the fourth the mean silhouette coefficient of the
#' solution and the last columns has the estimated C.Index for each one.
#' @export
#' @usage non_dominated_summary (output, prob_matrix, OS,
#' distancetype = "pearson")
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15,
#' prob_matrix = expression, OS = OS)
#' non_dominated_summary(
#'     output = output,
#'     OS = OS,
#'     prob_matrix = expression,
#'     distancetype = "pearson"
#' )
non_dominated_summary <-
    function(output, prob_matrix, OS, distancetype = "pearson") {
        if (!methods::is(output, "galgo.Obj")) {
            stop("object must be of class 'galgo.Obj'")
        }
        output_df <- to_dataframe(output)
        NonDom_solutions <- output_df[output_df$Rank == 1, ]
        calculate_distance <- select_distance(distancetype = distancetype
                                    )
        RESULT <- data.frame(
            solution = as.character(),
            k = as.numeric(),
            ngenes = as.numeric(),
            mean.Silhouette = as.numeric(),
            C.Index = as.numeric(),
            stringsAsFactors = FALSE
        )
        for (i in seq_len(nrow(NonDom_solutions))) {
            name <- rownames(NonDom_solutions)[i]
            genes <- NonDom_solutions[i, "Genes"][[1]]
            k <- NonDom_solutions[i, "k"]
            Sub_matrix <- prob_matrix[genes, ]
            D <- calculate_distance(Sub_matrix)
            true_class <- cluster_algorithm(D, k)
            Centroids <- k_centroids(Sub_matrix, true_class$cluster)
            predicted_class <- cluster_classify(Sub_matrix, Centroids,
                                        method = distancetype)
            predicted_class <- as.factor(predicted_class)
            predicted_classdf <- as.data.frame(predicted_class)
            surv_formula <- stats::as.formula("OS~ predicted_class")
            tumortotal <- survival::survfit(surv_formula)
            totalsdf <- survival::survdiff(surv_formula)
            tumortotalpval <- 1 - stats::pchisq(totalsdf$chisq,
                                        length(totalsdf$n) - 1)
            tumortotalpval <- format(tumortotalpval, digits = 4)
            coxsimple <- survival::coxph(surv_formula, data = predicted_classdf)
            CI <- survcomp::concordance.index(
                stats::predict(coxsimple, new = predicted_classdf),
                surv.time = OS[, 1],
                surv.event = OS[, 2],
                outx = FALSE
            )$c.index
            mean_Sil <- mean(cluster::silhouette(
                as.numeric(predicted_class), D)[, 3])
            row <- c(name, k, length(genes), mean_Sil, CI)
            RESULT[nrow(RESULT) + 1, ] <- row
        }
        return(RESULT)
    }

#' Create Centroids
#'
#' This functions create the signature centroids estimated from the
#' GalgoR output and the expression matrix of the training sets.
#'
#' @param output @param output An object of class \code{galgo.Obj}
#' @param solution_names A \code{character} vector with the names of the
#' solutions for which the centroids are to be calculated
#' @param trainset a \code{matrix} or \code{data.frame}. Must be an expression
#' matrix with features in rows and samples in columns
#' @param distancetype a \code{character} that can be either \code{'pearson'},
#' \code{'uncentered'}, \code{'spearman'} or \code{'euclidean'}
#'
#' @return Returns a list with the centroid matrix for each of the solutions
#' in \code{solution_names}, where each column represents the prototypic
#' centroid of a subtype and each row the constituents features of the
#' solution signature
#' @export
#' @usage create_centroids (output, solution_names, trainset,
#' distancetype = "pearson")
#'
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15,
#' prob_matrix = expression, OS = OS)
#' outputDF <- to_dataframe(output)
#' outputList <- to_list(output)
#'
#' RESULTS <- non_dominated_summary(
#'     output = output, OS = OS,
#'     prob_matrix = expression,
#'     distancetype = "pearson"
#' )
#' CentroidsList <- create_centroids(output, RESULTS$solution,
#' trainset = expression)
create_centroids <-
    function(output,
            solution_names,
            trainset,
            distancetype = "pearson") {
        calculate_distance <-
            select_distance(distancetype = distancetype)

        CentroidsList <- vector("list",length(solution_names)) 
        names(CentroidsList) <- solution_names
        output_df <- to_dataframe(output)
        for (j in solution_names) {
            genes <- output_df[j, "Genes"][[1]]
            k <- output_df[j, "k"]
            name <- j
            Sub_matrix <- trainset[genes, ]

            D <- calculate_distance(Sub_matrix)

            true_class <- cluster_algorithm(D, k)

            Centroids <- k_centroids(Sub_matrix, true_class$cluster)
            CentroidsList[[name]] <- Centroids
        }
        return(CentroidsList)
    }


#' Classify samples from multiple centroids
#'
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an
#' expression matrix with features in rows and samples in columns
#' @param centroid_list a\code{list} with the centroid matrix for each of
#' the signatures to evaluate, where each column represents the prototypic
#' centroid of a subtype and each row the constituents features of the
#' solution signature. The output of
#' \code{\link[GSgalgoR:create_centroids]{create_centroids}} can be used.
#' @param distancetype  a \code{character} that can be either
#' \code{'pearson'} (default), \code{'spearman'} or \code{'kendall'}.
#'
#' @return Returns a \code{data.frame} with the classes assigned to
#' each sample in each signature, were samples are a rows and signatures
#' in columns
#' @export
#'
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15,
#' prob_matrix = expression, OS = OS)
#' outputDF <- to_dataframe(output)
#' outputList <- to_list(output)
#'
#' RESULTS <- non_dominated_summary(
#'     output = output, OS = OS,
#'     prob_matrix = expression,
#'     distancetype = "pearson"
#' )
#' CentroidsList <- create_centroids(output, RESULTS$solution,
#' trainset = expression)
#' classes <- classify_multiple(prob_matrix = expression,
#' centroid_list = CentroidsList)
classify_multiple <-
    function(prob_matrix,
            centroid_list,
            distancetype = "pearson") {
        classes <-
            matrix(rep(NA, ncol(prob_matrix) * length(centroid_list)),
                ncol = length(centroid_list))
        as.data.frame <- classes
        colnames(classes) <- names(centroid_list)
        rownames(classes) <- colnames(prob_matrix)

        for (i in seq_len(length(centroid_list))) {
            centroids <- centroid_list[[i]]
            name <- names(centroid_list)[i]
            genes <- rownames(centroids)
            k <- ncol(centroids)
            Sub_matrix <- prob_matrix[genes, ]

            predicted_class <-
                cluster_classify(Sub_matrix, centroids, method = distancetype)

            predicted_class <- as.factor(predicted_class)
            classes[, name] <- predicted_class
        }

        return(classes)
    }

context("results-functions")

test_that("classifiy_multiple returns a list", {
    set.seed(29042010)
    library(breastCancerTRANSBIG)
    data(transbig)
    Train <- transbig
    expression <- Biobase::exprs(Train)
    clinical <- Biobase::pData(Train)
    OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
    
    expression <- expression[sample(seq_len(nrow(expression)), 100), ]
    expression <- t(scale(t(expression)))
   
    output <- GSgalgoR::galgo(generations = 2, population = 5, prob_matrix = expression, OS = OS, 
                            distancetype = "pearson", verbose = 1)
    summary_results<-non_dominated_summary(output = output,OS = OS,
                                           prob_matrix = expression, 
                                           distancetype = "pearson")
    centroids_list <- create_centroids(output, summary_results$solution, trainset = expression)
    classes <- classify_multiple(prob_matrix = expression, centroid_list = centroids_list)
    expect_is(classes,"matrix")
})

#' Distance to centroid classifier function
#'
#' Given an \eqn{n x m} matrix of centroids, where \eqn{m} are the prototypic 
#' centroids with \eqn{n} features, classify new samples according to the 
#' distance to the centroids.
#'
#' @param data a \code{data.frame} of dimensions \eqn{n x p} with the samples 
#' to classify, were \eqn{n} are the same set of features as in the centroids
#' @param centroid a \code{data.frame} of dimensions \eqn{n x m}, where each 
#' column is a prototypic centroid to classify the samples
#' @param method Character string indicating which method to use to calculate 
#' distance to centroid. Options are \code{"pearson"} (default), 
#' \code{"kendall"}, or \code{"spearman"}
#'
#' @return Returns a numeric vector of length \eqn{p} with the class assigned 
#' to each sample according to the shortest distance to centroid
#' @export
#'
#' @examples
#'
#' # load example dataset
#' require(iC10TrainingData)
#' require(pamr)
#'
#' data(train.Exp)
#' data(IntClustMemb)
#' TrainData <- list(x = train.Exp, y = IntClustMemb)
#'
#' # Create prototypic centroids
#' pam <- pamr.train(TrainData)
#' centroids <- pam$centroids
#'
#' Class <- cluster_classify(train.Exp, centroids)
#' table(Class, IntClustMemb)
cluster_classify <- function(data, centroid, method = "pearson") {
    R <- stats::cor(data, centroid, method = method)
    scores <- apply(R, 1, which.max)
}


#' Wrapper function to perform partition around medioids (PAM) for GalgoR
#'
#' In \code{GSgalgoR}, the partition around medioids (PAM) algorithm is the 
#' default clustering process used under the evolutionary process.
#'
#' @param c a dissimilarity matrix object of type \code{'dist'}
#' @param k positive integer specifying the number of clusters, less than the 
#' number of observations
#'
#' @return Returns a \code{'list'} with the value \code{'$cluster'} which 
#' contains the cluster assignment of each of the samples evaluated
#' @details The function runs the \code{\link[cluster:pam]{pam}} function of 
#' the \code{'cluster'} package 
#' with options \code{cluster.only =TRUE}, 
#' \code{diss = TRUE}, \code{do.swap=TRUE}, 
#' \code{keep.diss=FALSE}, \code{keep.data = FALSE}, 
#' \code{pamonce= 2}
#' @references
#' \itemize{
#' \item Reynolds, A., Richards, G., de la Iglesia, B. and Rayward-Smith, V. 
#' (1992) Clustering rules: A comparison of partitioning and 
#' hierarchical clustering algorithms; Journal of Mathematical Modelling and 
#' Algorithms 5, 475--504. 10.1007/s10852-005-9022-1.
#' \item Erich Schubert and Peter J. Rousseeuw (2019) Faster k-Medoids 
#' Clustering: Improving the PAM, CLARA, and CLARANS Algorithms; Preprint, 
#' (\url{https://arxiv.org/abs/1810.05691}).
#' }
#'
#' @export
#' @examples
#' # load example dataset
#' require(iC10TrainingData)
#' require(pamr)
#' data(train.Exp)
#'
#' calculate_distance <- select_distance(distancetype = "pearson")
#' Dist <- calculate_distance(train.Exp)
#' k <- 4
#' Pam <- cluster_algorithm(Dist, k)
#' table(Pam$cluster)
cluster_algorithm <- function(c, k) {
    return(list(
        cluster = cluster::pam(
            c,
            k,
            cluster.only = TRUE,
            diss = TRUE,
            do.swap = TRUE,
            keep.diss = FALSE,
            keep.data = FALSE,
            pamonce = 2
        )
    ))
}

#' Function for calculating the cosine similarity
#'
#' Cosine similarity is a metric of similarity between two non-zero vectors 
#' of an inner product space that measures the cosine of the angle between them.
#' Two vectors with the same orientation have a cosine similarity of 1, if 
#' they are perpendicular they have a similarity of 0, and if they have 
#' opposing directions the cosine similarity is -1, independent of their
#' magnitude.
#' One advantage of cosine similarity is its low-complexity, especially for 
#' sparse vectors where only the non-zero dimensions need to be considered, 
#' which is a common case in \code{GSgalgoR}.
#' Other names of cosine similarity are Otuska-Orchini similarity when it is 
#' applied to binary data, which is the case for \code{GSgalgoR}, where 
#' individual solutions represented as strings of 0 and 1 are compared with t
#' his metric.
#'
#' @param a,b A string of numbers with equal length. It can also be two 
#' binary strings of 0's and 1's
#'
#' @return In practice, the function can return numeric values from -1 to 1 
#' according the vector orientations, where a cosine similarity of 1 implies 
#' same orientation of the vectors while -1 imply vector of opposing directions.
#' In the binary application, values range from 0 to 1, where 0 are totally 
#' discordant vectors while 1 are identical binary vectors.
#' @export
#' @examples
#' solution1 <- c(1, 0, 0, 1, 0, 0, 1)
#' solution2 <- solution1
#' r <- cosine_similarity(solution1, solution2)
#' # the cosine similarity (r) equals 1
#' solution2 <- abs(solution1 - 1)
#' r2 <- cosine_similarity(solution1, solution2)
#' # the cosine similarity (r2) equals 0
cosine_similarity <- function(a, b) {
    a %*% b / sqrt(a %*% a * b %*% b)
}   # Calculates the cosine distance between two solutions to estimate the 
    #mutational rate

#' Function to calculate the centroids of different groups (classes)
#'
#' This function calculates the mean value for each feature of each class to 
#' calculate the prototypic centroids of the different groups
#' @param data a scaled gene expression \code{matrix} or \code{data.frame} 
#' with samples as columns and features as rows
#' @param class a vector with the samples classes
#'
#' @return returns a \code{data.frame} with the estimated prototypic centroids 
#' for each class with the features names as rownames
#' @export
#'
#' @examples
#' # load example dataset
#' require(iC10TrainingData)
#' require(pamr)
#'
#' data(train.Exp)
#'
#' calculate_distance <- select_distance(distancetype = "pearson")
#' Dist <- calculate_distance(train.Exp)
#' k <- 4
#' Pam <- cluster_algorithm(Dist, k)
#' table(Pam$cluster)
#' centroids <- k_centroids(train.Exp, Pam)
k_centroids <- function(data, class) {
    class_ul<-unlist(class)
    c <- unique(class_ul)
    L <- vector("list",length(c))
    
    for (i in c) {
        if (sum(class_ul == i) > 1) {
            x <- rowMeans(data[, class_ul == i])
            L[[i]] <- x
        } else {
            L[[i]] <- data[, class_ul == i]
        }
    }
    L <- t(do.call(rbind, L))
}

#' Convert galgo.Obj to list
#'
#' The current function transforms a \code{galgo.Obj} to a \code{list}
#'
#' @param output An object of class \code{galgo.Obj}
#'
#' @return The current function restructurates a \code{galgo.Obj} to a more 
#' easy to understand an use \code{list}. This output is particularly useful 
#' if one wants to select a given solution and use its outputs in a new 
#' classifier. The output of type \code{list} has a length equals to the 
#' number of solutions obtained by the \code{\link[GSgalgoR:galgo]{galgo}} 
#' algorithm.
#'
#' Basically this output is a list of lists, where each element of the output 
#' is named after the solution's name (\code{solution.n}, where \code{n} is 
#' the number assigned to that solution), and inside of it, it has all the 
#' constituents for that given solution with the following structure:
#' \enumerate{
#' \item \strong{output$solution.n$Genes}: A vector of the features included 
#' in the solution
#' \item \strong{output$solution.n$k}: The number of partitions found in that 
#' solution
#' \item \strong{output$solution.n$SC.Fit}: The average silhouette coefficient 
#' of the partitions found
#' \item \strong{output$solution.n$Surv.Fit}: The survival fitness value
#' \item \strong{output$solution.n$Rank}: The solution rank
#' \item \strong{CrowD}: The solution crowding distance related to the rest 
#' of the solutions
#' }
#' @export
#' @author Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
#'
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15, 
#' prob_matrix = expression, OS = OS)
#' outputDF <- to_dataframe(output)
#' outputList <- to_list(output)
to_list <- function(output) {
    if (!methods::is(output, "galgo.Obj")) {
        stop("object must be of class 'galgo.Obj'")
    }
    OUTPUT <- vector("list", nrow(Solutions(output)))
    Genes <-
        colnames(Solutions(output))[seq_len(ncol(Solutions(output)) - 5)]
    for (i in seq_len(nrow(Solutions(output)))) {
        Sol <- paste("Solution", i, sep = ".")
        names(OUTPUT)[i]<-Sol
        OUTPUT[[Sol]] <- list()
        OUTPUT[[Sol]][["Genes"]] <-
            Genes[as.logical(Solutions(output)[i, seq_len(length(Genes))])]
        OUTPUT[[Sol]]["k"] <- Solutions(output)[i, "k"]
        OUTPUT[[Sol]]["SC.Fit"] <-
            Solutions(output)[i, length(Genes) + 2]
        OUTPUT[[Sol]]["Surv.Fit"] <-
            Solutions(output)[i, length(Genes) + 3]
        OUTPUT[[Sol]]["rank"] <- Solutions(output)[i, "rnkIndex"]
        OUTPUT[[Sol]]["CrowD"] <- Solutions(output)[i, "CrowD"]
    }
    return(OUTPUT)
}

#' Convert galgo.Obj to data.frame
#'
#' The current function transforms a \code{galgo.Obj} to a \code{data.frame}
#'
#' @param output An object of class \code{galgo.Obj}
#'
#' @return The current function restructurates a \code{galgo.Obj} to a more 
#' easy to understand an use \code{data.frame}. The output \code{data.frame} 
#' has \eqn{ m x n} dimensions, were the rownames (\eqn{m}) are the solutions 
#' obtained by the \code{\link[GSgalgoR:galgo]{galgo}} algorithm. 
#' The columns has the following structure:
#' \enumerate{
#' \item \strong{Genes}: The features included in each solution in form 
#' of a \code{list}
#' \item \strong{k}: The number of partitions found in that solution
#' \item \strong{SC.Fit}: The average silhouette coefficient of the 
#' partitions found
#' \item \strong{Surv.Fit}: The survival fitness value
#' \item \strong{Rank}: The solution rank
#' \item \strong{CrowD}: The solution crowding distance related to the 
#' rest of the solutions
#' }
#' @export
#'
#' @author Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
#'
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15, 
#' prob_matrix = expression, OS = OS)
#' outputDF <- to_dataframe(output)
#' outputList <- to_list(output)
to_dataframe <- function(output) {
    if (!methods::is(output, "galgo.Obj")) {
        stop("object must be of class 'galgo.Obj'")
    }
    Genes <-
        colnames(Solutions(output))[seq_len(ncol(Solutions(output)) - 5)]
    ListGenes <- vector("list", nrow(Solutions(output)))
    for (i in seq_len(nrow(Solutions(output)))) {
        ListGenes[[i]] <- list()
        ListGenes[[i]] <-
            Genes[as.logical(Solutions(output)[i, seq_len(length(Genes))])]
    }

    OUTPUT <-
        data.frame(
            Genes = I(ListGenes),
            k = Solutions(output)[, "k"],
            SC.Fit = Solutions(output)[, ncol(Solutions(output)) - 3],
            Surv.Fit = Solutions(output)[, ncol(Solutions(output)) - 2],
            Rank = Solutions(output)[, "rnkIndex"],
            CrowD = Solutions(output)[, "CrowD"]
        )
    rownames(OUTPUT) <-
        paste("Solutions", seq_len(nrow(Solutions(output))), sep = ".")
    return(OUTPUT)
}

context("convert-functions")

test_that("galgo.Obj can be converted to list", {
  set.seed(29042010)
  # load example dataset
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  
  # We will use a reduced dataset for the example
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  
  # Now we scale the expression matrix
  expression <- t(scale(t(expression)))
  
  # Run galgo
  output <- GSgalgoR::galgo(generations = 2, population = 5, prob_matrix = expression, OS = OS, verbose = 1)
  output_dataframe <- to_list(output)
  expect_is(output_dataframe,"list")
  
})



test_that("galgo.Obj can be converted to data.frame", {
  set.seed(29042010)
  # load example dataset
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  
  # We will use a reduced dataset for the example
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  
  # Now we scale the expression matrix
  expression <- t(scale(t(expression)))
  
  # Run galgo

  output <- GSgalgoR::galgo(generations = 2, population = 5, prob_matrix = expression, OS = OS, verbose = 1 )
  output_dataframe <- to_dataframe(output)
  expect_is(output_dataframe,"data.frame")
  
})

#' Plot pareto front from an galgo.Obj
#'
#' @param output An object of class \code{galgo.Obj}
#'
#' @return This function returns a scatterplot showing the solutions found by 
#' Galgo accross all generations in the solution space, where the Silhouette 
#' Fitness is in the x-axis and the survival fitness in the y-axis.
#' A line is drawn over all non-dominated solutions showing the estimated 
#' Pareto front
#' @export
#'
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(1:nrow(expression), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15, 
#' prob_matrix = expression, OS = OS)
#' plot_pareto(output)
plot_pareto <- function(output) {
    SC.Fit <- Surv.Fit <- Gen <- NULL
    PARETO <- output@ParetoFront

    for (i in seq_len(length(PARETO))) {
        PARETO[[i]] <- as.data.frame(PARETO[[i]])
        PARETO[[i]]$Gen <- i
    }
    PARETO <- do.call(rbind, PARETO)
    colnames(PARETO) <- c("SC.Fit", "Surv.Fit", "Gen")

    output_df <- to_dataframe(output) # Transform output to dataframe
    output_df <- output_df[output_df$Rank == 1, ]
    output_df <- output_df[order(output_df$SC.Fit), ]

    PlotPareto <-
        ggplot2::ggplot(PARETO, ggplot2::aes(x = SC.Fit, 
                                        y = Surv.Fit, colour = Gen)) +
        ggplot2::geom_point() +
        ggplot2::theme_bw()
    PlotPareto <-
        PlotPareto + ggplot2::geom_point(
            ggplot2::aes(x = SC.Fit, y = Surv.Fit),
            colour = "black",
            size = 2,
            output_df
        ) + ggplot2::geom_line(ggplot2::aes(x = SC.Fit, y = Surv.Fit), 
                        colour = "black", output_df)
    PlotPareto <-
        PlotPareto + ggplot2::ggtitle("Galgo run Pareto front")
    print(PlotPareto)
    return(PlotPareto)
}

context("plot-functions")

test_that("plot_pareto returns a Grob Object", {
    set.seed(29042010)
    library(breastCancerTRANSBIG)
    data(transbig)
    Train <- transbig
    expression <- Biobase::exprs(Train)
    clinical <- Biobase::pData(Train)
    OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
    
    expression <- expression[sample(seq_len(nrow(expression)), 100), ]
    expression <- t(scale(t(expression)))

    output <- GSgalgoR::galgo(generations = 2, population = 3, prob_matrix = expression, OS = OS, 
                            distancetype = "pearson", verbose = 1)
    plot_output<-plot_pareto(output)
    expect_is(plot_output,"ggplot")
    
})

#' @title GSgalgoR:  A bi-objective evolutionary meta-heuristic to identify
#' robust transcriptomic classifiers associated with patient outcome across
#' multiple cancer types.
#'
#' @description This package was developed to provide a simple to use set of
#' functions to use the galgo algorithm. A multi-objective optimization
#' algorithm for disease subtype discovery based on a non-dominated sorting
#' genetic algorithm.
#'
#' Different statistical and machine learning approaches have long been
#' used to identify gene expression/molecular signatures with prognostic
#' potential in different cancer types. Nonetheless, the molecular
#' classification of tumors is a difficult task and the results obtained
#' via the current statistical methods are highly dependent on the features
#' analyzed, the number of possible tumor subtypes under consideration, and
#' the underlying assumptions made about the data. In addition, some cancer
#' types are still lacking prognostic signatures and/or of subtype-specific
#' predictors which are continually needed to further dissect tumor biology.
#' In order to identify specific molecular phenotypes to develop precision
#' medicine strategies we present Galgo: A multi-objective optimization
#' process based on a non-dominated sorting genetic algorithm that combines
#' the advantages of clustering methods for grouping heterogeneous omics data
#' and the exploratory properties of genetic algorithms (GA) in order to find
#' features that maximize the survival difference between subtypes while
#' keeping high cluster consistency.
#'
#' \tabular{ll}{ Package: \tab GSgalgoR\cr Type: \tab Package\cr
#' Version: \tab 1.0.0\cr Date: \tab 2020-05-06 \cr License: \tab GPL-3\cr
#' Copyright: \tab (c) 2020 Martin E. Guerrero-Gimenez.\cr URL: \tab
#' \url{https://www.github.com/harpomaxx/galgo}\cr LazyLoad: \tab yes\cr
#' }
#'
#' @author
#' Martin E. Guerrero-Gimenez \email{mguerrero@@mendoza-conicet.gob.ar}
#'
#' Maintainer: Carlos A. Catania \email{harpomaxx@@gmail.com }
#' @docType package
#' @name GSgalgoR-package
#' @aliases GSgalgoR-package GSgalgoR
#' @importFrom  methods new
NULL


#' Galgo Object class
#'
#' @slot Solutions matrix.
#' @slot ParetoFront list.
#'
#'
#' @export
#'
#' @examples
galgo.Obj <- setClass( # Set the name for the class
    "galgo.Obj",
    # Define the slots
    slots = c(
        Solutions = "matrix",
        ParetoFront = "list"
    )
)

setGeneric("Solutions", function(x) standardGeneric("Solutions"))
setGeneric("ParetoFront", function(x) standardGeneric("ParetoFront"))
setMethod("Solutions", "galgo.Obj", function(x) x@Solutions)
setMethod("ParetoFront", "galgo.Obj", function(x) x@ParetoFront)

#' Survival Mean
#'
#' @param x
#' @param rmean
#'
#' @return
#' @noRd
#' @examples
RMST <- function(ft, rmean) {
    nstrat <- length(ft$strata)
    stemp <- rep(seq_len(nstrat), ft$strata)
    rmst <- numeric(length(nstrat)) 
    for (i in seq_len(nstrat)) {
        who <- (stemp == i)
        idx <- ft$time[who] <= rmean
        wk.time <- sort(c(ft$time[who][idx], rmean))
        wk.surv <- ft$surv[who][idx]
        wk.n.risk <- ft$n.risk[who][idx]
        wk.n.event <- ft$n.event[who][idx]
        time.diff <- diff(c(0, wk.time))
        areas <- time.diff * c(1, wk.surv)
        rmst_x <- sum(areas)
        # rmst <- c(rmst, rmst_x)
        rmst[i] <- rmst_x
    }
    return(rmst)
}


#' create_folds splits the data into k groups to perform cross-validation
#'
#' @param y a vector of outcomes
#' @param k an integer for the number of folds
#' @param list logical - should the results be in a list (TRUE) or in a vector
#' @param returnTrain a logical. When true, the values returned are the sample
#' positions correspondingto the data used during training. This argument only
#' works in conjunction withlist = TRUE
#'
#' @return if list=TRUE, it returns a list with k elements were each element
#' of the list has the position of the outcomes included in said fold,
#' if list=FALSE the function returns a vector where each outcome is assigned
#' to a given fold from 1 to k
#'
#' @examples
#' y <- rnorm(100, 5, 2) # A vector of outcomes
#' k <- 5 # Number of folds
#' create_folds(y, k = k, list = TRUE)
#' @noRd
#'
create_folds <-
    function(y, k = 10, list = TRUE, returnTrain = FALSE) {
        if (class(y)[1] == "Surv") {y <- y[, "time"]}
        if (is.numeric(y)) {
            cuts <- floor(length(y) / k)
            if (cuts < 2) {cuts <- 2}
            if (cuts > 5) {cuts <- 5}
            breaks <-
                unique(stats::quantile(y, probs = seq(0, 1, length = cuts)))
            y <- cut(y, breaks, include.lowest = TRUE)
        }
        if (k < length(y)) {
            y <- factor(as.character(y))
            numInClass <- table(y)
            foldVector <- vector(mode = "integer", length(y))
            for (i in seq_len(length(numInClass))) {
                min_reps <- numInClass[i] %/% k
                if (min_reps > 0) {
                    spares <- numInClass[i] %% k
                    seqVector <- rep(seq_len(k), min_reps)
                    if (spares > 0) {
                        seqVector <- c(seqVector, sample(seq_len(k), spares))
                    }
                    foldVector[which(y == names(numInClass)[i])] <-
                        sample(seqVector)
                }
                else {
                    foldVector[which(y == names(numInClass)[i])] <-
                        sample(seq_len(k), size = numInClass[i]
                        )
                }
            }
        }
        else {
            foldVector <- seq(along = y)
        }
        if (list) {
            out <- split(seq(along = y), foldVector)
            names(out) <-
                paste("Fold", gsub(" ", "0", format(seq(along = out))),sep = "")
            if (returnTrain) {
                out <- lapply(out, function(data, y) {y[-data]},
                            y = seq(along = y))
            }
        }
        else {
            out <- foldVector
        }
        out
    }

#' Harmonic mean
#'
#' The harmonic mean can be expressed as the reciprocal of the arithmetic
#' mean of the reciprocals of a given set of observations.
#' Since the harmonic mean of a list of numbers tends strongly toward
#' the least elements of the list, it tends (compared to the arithmetic mean)
#' to mitigate the impact of large outliers and aggravate the impact
#' of small ones.
#'
#' @param a a numeric vector of length > 1
#'
#' @return returns the harmonic mean of the values in \code{a}
#' @noRd
#' @examples
#' x <- rnorm(5, 0, 1) # five random numbers from the normal distribution
#' x <- c(x, 20) # add outlier
#' hmean(x)
hmean <- function(a) {
    1 / mean(1 / a)
}

#' Harmonic mean of the distance between consecutive groups
#'
#' Implements the harmonic mean of the distance between consecutive
#' groups multiplied by the number of comparisons:
#' \eqn{consecutive_distance = [n/ (1/x1-x2 + 1/x2-x3 +...1/xn-1 - xn)] * n-1}
#'
#' @param x A numeric vector of length > 1
#'
#' @return The function computes the harmonic mean of the differences
#' between consecutive groups multiplied by the number of comparisons and
#' returns a positive number. This function is used inside \code{fitness}
#' function.
#' @noRd
#' @examples
#' V <- c(4.5, 3, 7, 11)
#' consecutive_distance(V)
consecutive_distance <- function(x) {
    d <- x[order(x)]
    l <- length(d) - 1
    c <- c(0, 1)
    dif <- numeric(length(l))
    for (i in seq_len(l)) {
        #dif <- c(dif, diff(d[c + i]))
        dif[i] <- diff(d[c + i])
    }
    return(hmean(dif) * l)
}




#' Survival fitness function using the Restricted Mean Survival Time (RMST)
#' of each group
#'
#' Survival fitness function using the Restricted Mean Survival Time (RMST)
#' of each group as proposed by \emph{Dehbi & Royston et al. (2017)}.
#'
#' @param OS a \code{survival} object with survival data of the patients
#' evaluated
#' @param clustclass a numeric vector with the group label for each patient
#' @param period a number representing the period of time to evaluate in the
#' RMST calculation
#'
#' @return The function computes the Harmonic mean of the differences
#' between Restricted Mean Survival Time (RMST) of consecutive survival
#' curves multiplied by the number of comparisons.
#'
#' @references Dehbi Hakim-Moulay, Royston Patrick, Hackshaw Allan. Life
#' expectancy difference and life expectancy ratio: two measures of treatment
#' effects in randomized trials with non-proportional
#' hazards BMJ 2017; 357 :j2250 \url{https://www.bmj.com/content/357/bmj.j2250}
#' @author Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
#' @export
#'
#' @examples
#'
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' library(Biobase)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' clinical <- pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' surv_fitness(OS, clustclass = clinical$grade, period = 3650)
surv_fitness <- function(OS, clustclass, period) {
    score <- tryCatch(
        {   # This function calculates the RMST (comes from package survival)
            t <-
                RMST(survival::survfit(OS ~ clustclass), rmean = period)

            consecutive_distance(t)
        },
        error = function(e) {
            return(0)
        }
    )       # If consecutive_distance cannot be calculated,
            #the difference is set to 0 (no difference between curves)
    return(score)
}

## Helpers Functions to vectorize crossvalidation

#' Title
#'
#' @param flds
#' @param Data
#'
#' @return
#'
#' @examples
#' @noRd
build_train <- function(flds, data) {
    data[, -flds]
}

#' Title
#'
#' @param flds
#' @param Data
#'
#' @return
#'
#' @examples
#' @noRd
build_test <- function(flds, data) {
    data[, flds]
}


#' Title
#'
#' @param f
#'
#'
#' @return
#'
#' @examples
#' @noRd
#'
subset_distance <- function(flds, distance_data) {
    # sub <- subset(D, -flds) #experimental function from cba package
    # sub<- usedist::dist_subset(D, -flds)
    proxy::as.dist(proxy::as.matrix(distance_data)[-flds, -flds])
}

#' Title
#'
#' @param C
#'
#' @return
#'
#' @examples
#' @noRd
alloc2 <- function(C) {
    Ct <- t(C)
    ord <- matchingR::galeShapley.marriageMarket(C, Ct)
    return(ord$engagements)
}


#' Title
#'
#' @param C
#' @param ord
#'
#' @return
#'
#' @examples
#' @noRd
reord <- function(C, ord) {
    C <- C[, ord]
}

#' Survival crossvalidation
#'
#' crossvalidation function based on:
#' https://www.ncbi.nlm.nih.gov/pmc/articles/PMC3105299/
#' Data is the expression matrix
#' flds is a list with the indexes to partition the data in n different folds
#' indv is the solution to test, namely, a binary vector to subset the genes
#' to test
#' The function returns two fitness: fit_1 (the mean silhouette) and
#' fit_2 (the ad-hoc function to estimate the differences between curves)

#' @param Data
#' @param flds
#' @param indv
#' @param k
#' @param surv_obj
#' @param distance
#' @param nCV
#' @param period
#'
#' @return
#'
#' @examples
#' @noRd
crossvalidation <-
    function(data,
            flds,
            indv,
            k,
            surv_obj,
            distance,
            nCV,
            period) {
        data <- data[indv, ]
        distance_data <- distance(data)
        train_a <- lapply(flds, build_train, data = data)
        test_a <- lapply(flds, build_test, data = data)
        sub <- lapply(flds, subset_distance, distance_data = distance_data)
        #hc <- sapply(sub, cluster_algorithm, k = k)
        hc <- lapply(sub, function(x,k)cluster_algorithm(x,k)$cluster, k = k)
        centroids <- mapply(k_centroids, train_a, hc, SIMPLIFY = FALSE)
        centroids_cor <- mapply(stats::cor, centroids[1], centroids[2:nCV],
                                SIMPLIFY = FALSE)
        cord <- lapply(centroids_cor, alloc2)
        cord <- append(list(as.matrix(seq_len(k), ncol = 1)), cord, 1)
        centroids <- mapply(reord, centroids, cord, SIMPLIFY = FALSE)
        class_results <- mapply(cluster_classify, test_a, centroids,
                                SIMPLIFY = FALSE)
        cluster_class <- unlist(class_results)
        cluster_class <- cluster_class[order(as.vector(unlist(flds)))]
        fit_silhouette <- mean(cluster::silhouette(cluster_class,
                                        distance_data)[, 3])
        fit_differences <- surv_fitness(surv_obj, cluster_class, period)
        return(c(fit_silhouette, fit_differences))
    }


#' Minimum number of genes to use in a solution (A constraint for the algorithm)
#'
#' @param x
#' @param chrom_length
#'
#' @return
#'
#' @examples
#' @noRd
mininum_genes <- function(x, chrom_length) {
    sum(x) >= 10 & sum(x) < chrom_length
}

#' Uniform crossover
#'
#' @param a
#' @param b
#'
#' @return
#'
#' @examples
#' @noRd
uniform_crossover <- function(a, b) {
    if (length(a) != length(b)) {
        stop("vectors of unequal length")
    }
    l <- length(a)
    points <- as.logical(stats::rbinom(l, 1, prob = stats::runif(1)))
    achild <- numeric(l)
    achild[points] <- a[points]
    achild[!points] <- b[!points]
    bchild <- numeric(l)
    bchild[points] <- b[points]
    bchild[!points] <- a[!points]
    return(list(achild, bchild))
}


#' Asymmetric mutation operator:
#' Analysis of an Asymmetric Mutation Operator; Jansen et al.
#'
#' @param x
#'
#' @return
#'
#' @examples
#' @noRd
asymetric_mutation <- function(x) {
    chrom_length <- length(x)
    res <- x
    Active <- sum(x)
    Deactive <- chrom_length - Active
    mutrate1 <- 1 / Active
    mutrate2 <- 1 / Deactive
    mutpoint1 <-
        sample(c(1, 0),
            Deactive,
            prob = c(mutrate2, 1 - mutrate2),
            replace = TRUE
        )
    res[x == 0] <- abs(x[x == 0] - mutpoint1)

    mutpoint2 <-
        sample(c(1, 0),
            Active,
            prob = c(mutrate1, 1 - mutrate1),
            replace = TRUE
        )
    res[x == 1] <- abs(x[x == 1] - mutpoint2)
    return(res)
}


#' Offspring creation
#'
#' @param X1
#' @param chrom_length
#' @param population
#' @param TournamentSize
#'
#' @return
#'
#' @examples
#' @noRd
offsprings <- function(X1,
                    chrom_length,
                    population,
                    TournamentSize) {
    # Create empty matrix to add new individuals
    New <- matrix(NA, ncol = chrom_length, nrow = population)
    # same for cluster chromosome
    NewK <- matrix(NA, nrow = 1, ncol = population)
    # Use tournament selection, to select parents that will give offsprings
    matingPool <- nsga2R::tournamentSelection(X1, population, TournamentSize)
    # Count how many offsprings are still needed to reach population size
    count <- 0
    while (anyNA(New)) {
        count <- count + 1
        ## a.Select a pair of parent chromosomes from the matingPool
        Pair <- sample(seq_len(nrow(matingPool)), 2, replace = FALSE)
        # multiple point crossingover
        offsprings <-uniform_crossover(matingPool[Pair[1],
                                            seq_len(chrom_length)],
                                            matingPool[Pair[2],
                                            seq_len(chrom_length)])
        off1 <- offsprings[[1]]
        off2 <- offsprings[[2]]
        ## c.Mutate the two offsprings at each locus with probability Mp
        Mp <- cosine_similarity(matingPool[Pair[1], seq_len(chrom_length)],
                                matingPool[Pair[2], seq_len(chrom_length)])
        if (sample(c(1, 0), 1, prob = c(Mp, 1 - Mp)) == 1) {
            off1 <- asymetric_mutation(off1)
        }
        if (sample(c(1, 0), 1, prob = c(Mp, 1 - Mp)) == 1) {
            off2 <- asymetric_mutation(off2)
        }
        p <- 0.3 # Mutation for k (number of partitions)
        probs <- rep((1 - p) / 9, 9)
        k1 <- matingPool[Pair[1], "k"]
        k2 <- matingPool[Pair[2], "k"]
        probs[k1 - 1] <- probs[k1 - 1] + p / 2
        probs[k2 - 1] <- probs[k2 - 1] + p / 2
        offk1 <- sample(2:10, 1, prob = probs)
        offk2 <- sample(2:10, 1, prob = probs)
        # Add offsprings to new generation
        New[count, ] <- off1
        New[count + 1, ] <- off2
        NewK[, count] <- offk1
        NewK[, count + 1] <- offk2
    }
    return(list(New = New, NewK = NewK))
}

#' Title
#' Penalize Fitness2 function according the number of genes
#' @param x
#'
#' @return
#'
#' @examples
#' @noRd
penalize <- function(x) {
    1 / (1 + (x / 500)^2)
}


#' GSgalgoR main function
#'
#' \code{\link[GSgalgoR:galgo]{galgo}} accepts an expression matrix and a
#' survival object to find robust gene expression signatures related to a
#' given outcome
#'
#' @param population  a number indicating the number of solutions in the
#' population of solutions that will be evolved
#' @param generations a number indicating the number of iterations of the
#' galgo algorithm
#' @param nCV number of cross-validation sets
#' @param distancetype character, it can be
#' \code{'pearson'} (centered pearson), \code{'uncentered'}
#' (uncentered pearson), \code{'spearman'} or \code{'euclidean'}
#' @param TournamentSize a number indicating the size of the tournaments for
#' the selection procedure
#' @param period a number indicating the outcome period to evaluate the RMST
#' @param OS a \code{survival} object (see \code{ \link[survival]{Surv} }
#' function from the \code{\link{survival}} package)
#' @param prob_matrix a \code{matrix} or \code{data.frame}. Must be an
#' expression matrix with features in rows and samples in columns
#' @param res_dir a \code{character} string indicating where to save the
#' intermediate and final output of the algorithm
#' @param start_galgo_callback optional callback function for the start
#' of the galgo execution
#' @param end_galgo_callback optional callback function for the end of the
#' galgo execution
#' @param report_callback optional callback function
#' @param start_gen_callback optional callback function for the beginning
#' of the run
#' @param end_gen_callback optional callback function for the end of the run
#' @param verbose select the level of information printed during galgo
#' execution
#'
#' @return an object of type \code{'galgo.Obj'} that corresponds to a list
#' with the elements \code{$Solutions} and \code{$ParetoFront}.
#' \code{$Solutions} is a \eqn{l x (n + 5)} matrix where \eqn{n} is the number
#' of features evaluated and \eqn{l} is the number of solutions obtained.
#' The submatrix \eqn{l x n} is a binary matrix where each row represents
#' the chromosome of an evolved solution from the solution population, where
#' each feature can be present (1) or absent (0) in the solution.
#' Column \eqn{n +1} represent the  \eqn{k} number of clusters for each
#' solutions. Column \eqn{n+2} to \eqn{n+5} shows the SC Fitness and
#' Survival Fitness values, the solution rank, and the crowding distance of
#' the solution in the final pareto front respectively.
#' For easier interpretation of the \code{'galgo.Obj'}, the output can be
#' reshaped using the \code{\link[GSgalgoR:to_list]{to_list}} and
#' \code{\link[GSgalgoR:to_dataframe]{to_dataframe}} functions
#'
#' @export
#'
#' @usage galgo (population = 30, generations = 2, nCV = 5,
#' distancetype = "pearson", TournamentSize = 2, period = 1825,
#' OS, prob_matrix, res_dir = "", start_galgo_callback = callback_default,
#' end_galgo_callback = callback_base_return_pop,
#' report_callback = callback_base_report,
#' start_gen_callback = callback_default,
#' end_gen_callback = callback_default,
#' verbose = 2)
#'
#' @author Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
#'
#' @examples
#' # load example dataset
#' library(breastCancerTRANSBIG)
#' data(transbig)
#' Train <- transbig
#' rm(transbig)
#'
#' expression <- Biobase::exprs(Train)
#' clinical <- Biobase::pData(Train)
#' OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#'
#' # We will use a reduced dataset for the example
#' expression <- expression[sample(seq_len(nrow(expression)), 100), ]
#'
#' # Now we scale the expression matrix
#' expression <- t(scale(t(expression)))
#'
#' # Run galgo
#' output <- GSgalgoR::galgo(generations = 5, population = 15,
#' prob_matrix = expression, OS = OS)
#' outputDF <- to_dataframe(output)
#' outputList <- to_list(output)
galgo <- function(population = 30,# Number of individuals to evaluate
                generations = 2, # Number of generations
                nCV = 5,# Number of crossvalidations for function
                        # "crossvalidation"
                distancetype = "pearson",
                TournamentSize = 2,
                period = 1825,
                OS, # OS=Surv(time=clinical$time,event=clinical$status)
                prob_matrix,
                res_dir = "",
                start_galgo_callback = callback_default,
                end_galgo_callback = callback_base_return_pop,
                report_callback = callback_base_report,
                start_gen_callback = callback_default,
                end_gen_callback = callback_default,
                verbose = 2) {
    if (verbose == 0) {
        report_callback <- callback_default
        start_gen_callback <- callback_default
        end_gen_callback <- callback_default
    }

    if (verbose == 1) {
        report_callback <- callback_no_report
        start_gen_callback <- callback_default
        end_gen_callback <- callback_default
    }

    # Support for parallel computing.
    chk <- Sys.getenv("_R_CHECK_LIMIT_CORES_", "")
    if (nzchar(chk) && tolower(chk) == "true") {
        # use 2 cores in CRAN/Travis/AppVeyor
        num_workers <- 3L
    } else {
        # use all cores in devtools::test()
        num_workers <- parallel::detectCores()
    }
    cluster <-
        # convention to leave 1 core for OS
        parallel::makeCluster(num_workers - 1)
    doParallel::registerDoParallel(cluster)
    on.exit(parallel::stopCluster(cluster))
    on.exit()
    calculate_distance <- select_distance(distancetype)
    # Empty list to save the solutions.
    #PARETO <- list()
    PARETO <- vector("list",generations)
    chrom_length <- nrow(prob_matrix)
    # 1. Create random population of solutions.

    # Creating random clusters from 2-10.
    Nclust <- sample(2:10, population, replace = TRUE)

    # Matrix with random TRUE false with uniform distribution,
    # representing solutions to test.
    X <- matrix(NA, nrow = population, ncol = chrom_length)
    for (i in seq_len(population)) {
        prob <- stats::runif(1, 0, 1)
        X[i, ] <-
            sample(c(1, 0),
                chrom_length,
                replace = TRUE,
                prob = c(prob, 1 - prob)
            )
    }
    X1<-X
    start_galgo_callback(
        userdir = res_dir,
        generation = 0,
        pop_pool = X1,
        pareto = PARETO,
        prob_matrix = prob_matrix,
        current_time = start_time
    )

    ##### Main loop.
    end_OK <- TRUE
    for (g in seq_len(generations)) {
        # Output for the generation callback
        #callback_data <- list()
        #environment(start_gen_callback) <- environment()
        start_time <- Sys.time() # Measures generation time

        start_gen_callback(
            userdir = res_dir,
            generation = g,
            pop_pool = X1,
            pareto = PARETO,
            prob_matrix = prob_matrix,
            current_time = start_time
        )


        # 2.Calculate the fitness f(x) of each chromosome x in the population.
        # Apply constraints (min 10 genes per solution).
        # TODO: Check chrom_length parameter
        Fit1 <- apply(X, 1, mininum_genes, chrom_length = chrom_length)
        X <- X[Fit1, ]
        if (is.null(dim(X))){
            message("Galgo was unable to find a suitable solution. Consider 
                    using a bigger population.")
            end_OK <- FALSE
            break;
        }
        #message(Fit1)
        #message(dim(X))
        X <- apply(X, 2, as.logical)
        n <- nrow(X)
        Nclust <- Nclust[Fit1]

        k <- Nclust

        flds <- create_folds(seq_len(ncol(prob_matrix)), k = nCV)

        `%dopar%` <- foreach::`%dopar%`
        `%do%` <- foreach::`%do%`
        reqpkgs <-
            c("cluster", "proxy", "survival", "matchingR", "GSgalgoR")
        # reqpkgs <- c("cluster","cba", "survival", "matchingR")

        # Calculate Fitness 1 (silhouette) and 2 (Survival differences).
        Fit2 <- foreach::foreach(
            i = seq_len(nrow(X)),
            .packages = reqpkgs,
            .combine = rbind
        ) %dopar% {
            # devtools::load_all() # required for package devel
            crossvalidation(
                prob_matrix,
                flds,
                X[i, ],
                k[i],
                surv_obj = OS,
                distance = calculate_distance,
                nCV,
                period
            )
        }

        # Penalization of SC by number of genes.
        Fit2[, 1] <- (Fit2[, 1] * penalize(rowSums(X)))

        if (g == 1) {
            PARETO[[g]] <-
                Fit2    # Saves the fitness of the solutions of the
                        #current generation.
            # NonDominatedSorting from package nsga2R. -1
            # multiplication to alter the sign of the fitness
            # (function sorts from min to max).
            ranking <-
                nsga2R::fastNonDominatedSorting(Fit2 * -1)
            rnkIndex <- integer(n)
            i <- 1
            while (i <= length(ranking)) {
                # Save the rank of each solution.
                rnkIndex[ranking[[i]]] <- i
                i <- i + 1
            }
            # Data.frame with solution vector, number of clusters and ranking.
            X1 <-
                cbind(X, k, Fit2, rnkIndex)
            # Range of fitness of the solutions.
            objRange <-
                apply(Fit2, 2, max) - apply(Fit2, 2, min)
            # Crowding distance of each front (nsga2R package).
            CrowD <-
                nsga2R::crowdingDist4frnt(X1, ranking, objRange)
            CrowD <- apply(CrowD, 1, sum)
            # data.frame with solution vector, number of clusters,
            # ranking and crowding distance.

            X1 <-
                cbind(X1, CrowD)
            # Output for the generation callback
            report_callback(
                userdir = res_dir,
                generation = g,
                pop_pool = X1,
                pareto = PARETO,
                prob_matrix = prob_matrix,
                current_time =  Sys.time()
            )



            # Save parent generation.
            Xold <- X
            Nclustold <- Nclust

            # 3. create offspring.
            NEW <-
                offsprings(X1, chrom_length, population, TournamentSize)
            X <- NEW[["New"]]
            Nclust <- NEW[["NewK"]]
        } else {
            oldnew <- rbind(PARETO[[g - 1]], Fit2)
            oldnewfeature <- rbind(Xold, X)
            oldnewNclust <- c(Nclustold, Nclust)
            oldnewK <- oldnewNclust
            # NonDominatedSorting from package nsga2R. -1 multiplication to
            # alter the sign of the fitness (function sorts from min to max).
            rnkIndex2 <- integer(nrow(oldnew))
            ranking2 <-
                nsga2R::fastNonDominatedSorting(oldnew * -1)
            i <- 1
            while (i <= length(ranking2)) {
                # saves the rank of each solution.
                rnkIndex2[ranking2[[i]]] <- i
                i <- i + 1
            }

            X1 <-
                cbind(oldnewfeature,
                    k = oldnewK,
                    oldnew,
                    rnkIndex = rnkIndex2
                )
            # Range of fitness of the solutions.
            objRange <-
                apply(oldnew, 2, max) - apply(oldnew, 2, min)
            # Crowding distance of each front (nsga2R package).
            CrowD <-
                nsga2R::crowdingDist4frnt(X1, ranking2, objRange)
            CrowD <- apply(CrowD, 1, sum)
            # data.frame with solution vector, number of clusters,
            # ranking and crowding distance
            X1 <-
                cbind(X1, CrowD)
            X1 <- X1[X1[, "CrowD"] > 0, ]
            O <- order(X1[, "rnkIndex"],
                    X1[, "CrowD"] * -1)[seq_len(population)]
            X1 <- X1[O, ]
            # Saves the fitness of the solutions of the current generation
            PARETO[[g]] <-
                X1[, (chrom_length + 2):(chrom_length + 3)]
            # Output for the generation callback
            report_callback(
                userdir = res_dir,
                generation = g,
                pop_pool = X1,
                pareto = PARETO,
                prob_matrix = prob_matrix,
                current_time = Sys.time()
            )


            Xold <- X1[, seq_len(chrom_length)]
            Nclustold <- X1[, "k"]

            NEW <-
                offsprings(X1, chrom_length, population, TournamentSize)
            X <- NEW[["New"]]
            Nclust <- NEW[["NewK"]]
        }

        # 5.Go to step 2
        gc()

        end_gen_callback(
            userdir = res_dir,
            generation = g,
            pop_pool = X1,
            pareto = PARETO,
            prob_matrix = prob_matrix,
            current_time = Sys.time()
        )
    }

    parallel::stopCluster(cluster)
    if( end_OK == TRUE ){
        return (end_galgo_callback(
            userdir = res_dir,
            generation = g,
            pop_pool = X1,
            pareto = PARETO,
            prob_matrix = prob_matrix,
            current_time = Sys.time()
        ))
    }
}

context("callback functions")


test_that("final population is saved in /tmp/", {
  set.seed(29042010)
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  expression <- t(scale(t(expression)))
  tmpdir<-tempdir()
  output <- GSgalgoR::galgo(res_dir = tmpdir,
                          generations = 2, 
                          population = 3, 
                          prob_matrix = expression, 
                          OS = OS,
                          verbose = 0,
                          end_galgo_callback = callback_base_save_pop_final)
  expect_true(file.exists(file.path(tmpdir,"final.rda")))
})

#test_that("partial population is saved in /tmp/", {
#  # load example dataset
#  library(breastCancerTRANSBIG)
#  data(transbig)
#  Train <- transbig
#  expression <- Biobase::exprs(Train)
#  clinical <- Biobase::pData(Train)
#  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
#  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
#  expression <- t(scale(t(expression)))
#  output <- GSgalgoR::galgo(res_dir = "/tmp/",
#                          generations = 3, 
#                          population = 3, 
#                          prob_matrix = expression, 
#                          OS = OS,
#                          verbose = 0,
#                          end_gen_callback = callback_base_save_pop_partial )
#  expect_true(file.exists("/tmp/2.rda"))
#})

context("distance-functions")

test_that("pearson distance works", {
  set.seed(29042010)
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  expression <- t(scale(t(expression)))

  output <- GSgalgoR::galgo(generations = 2, population = 3, prob_matrix = expression, OS = OS, 
                          distancetype = "pearson", verbose =1 )
  expect_is(output,"galgo.Obj")
  
})


test_that("spearman distance works", {
  set.seed(29042010)
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  expression <- t(scale(t(expression)))
  
  output <- GSgalgoR::galgo(generations = 2, population = 3, prob_matrix = expression, OS = OS, 
                          distancetype = "spearman", verbose = 1)
  expect_is(output,"galgo.Obj")
  
})


test_that("euclidean distance works", {
  set.seed(29042010)
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  expression <- t(scale(t(expression)))
  
  output <- GSgalgoR::galgo(generations = 2, population = 3, prob_matrix = expression, OS = OS, 
                          distancetype = "euclidean", verbose = 1)
  expect_is(output,"galgo.Obj")
  
})

test_that("uncentered distance works", {
  set.seed(29042010)
  library(breastCancerTRANSBIG)
  data(transbig)
  Train <- transbig
  expression <- Biobase::exprs(Train)
  clinical <- Biobase::pData(Train)
  OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  
  # We will use a reduced dataset for the example
  expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  
  # Now we scale the expression matrix
  expression <- t(scale(t(expression)))
  
  # Run galgo
  
  output <- GSgalgoR::galgo(generations = 2, population = 3, prob_matrix = expression, OS = OS, 
                          distancetype = "uncentered", verbose = 0)
  expect_is(output,"galgo.Obj")
  
})

context("galgo function")

test_that("a valid galgo.Obj is generated", {
   set.seed(29042010)
  # load example dataset
   library(breastCancerTRANSBIG)
   data(transbig)
   Train <- transbig
  
   expression <- Biobase::exprs(Train)
   clinical <- Biobase::pData(Train)
   OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
  
   # We will use a reduced dataset for the example
   expression <- expression[sample(seq_len(nrow(expression)), 100), ]
  
   # Now we scale the expression matrix
   expression <- t(scale(t(expression)))
  
   # Run galgo

   output <- GSgalgoR::galgo(generations = 2, population = 5, 
      prob_matrix = expression, OS = OS)
   expect_is(output,"galgo.Obj")
  
})


test_that("a valid galgo.Obj is generated using verbose 1", {
   set.seed(29042010)
   # load example dataset
   library(breastCancerTRANSBIG)
   data(transbig)
   Train <- transbig
   
   expression <- Biobase::exprs(Train)
   clinical <- Biobase::pData(Train)
   OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
   
   # We will use a reduced dataset for the example
   expression <- expression[sample(seq_len(nrow(expression)), 100), ]
   
   # Now we scale the expression matrix
   expression <- t(scale(t(expression)))
   
   # Run galgo
 
   output <- GSgalgoR::galgo(generations = 2, 
                           population = 4, 
                           prob_matrix = expression,
                           OS = OS,
                           verbose = 1)
   expect_is(output,"galgo.Obj")
   
})

test_that("a valid galgo.Obj is generated using verbose 0", {
   set.seed(29042010)
   # load example dataset
   library(breastCancerTRANSBIG)
   data(transbig)
   Train <- transbig
   
   expression <- Biobase::exprs(Train)
   clinical <- Biobase::pData(Train)
   OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
   
   # We will use a reduced dataset for the example
   expression <- expression[sample(seq_len(nrow(expression)), 100), ]
   
   # Now we scale the expression matrix
   expression <- t(scale(t(expression)))
   
   # Run galgo
   
   output <- GSgalgoR::galgo(generations = 2, 
                           population = 4, 
                           prob_matrix = expression,
                           OS = OS,
                           verbose = 0)
   expect_is(output,"galgo.Obj")
   
})

test_that("not suitable solution is correctly handled", {
   set.seed(29042010)
   # load example dataset
   library(breastCancerTRANSBIG)
   data(transbig)
   Train <- transbig
   
   expression <- Biobase::exprs(Train)
   clinical <- Biobase::pData(Train)
   OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
   
   # We will use a reduced dataset for the example
   expression <- expression[sample(seq_len(nrow(expression)), 100), ]
   
   # Now we scale the expression matrix
   expression <- t(scale(t(expression)))
   
   # Run galgo
   
   output <- GSgalgoR::galgo(generations = 2, 
                             population = 1, 
                             prob_matrix = expression,
                             OS = OS,
                             verbose = 0)
  expect_null(output)
   
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster-classifier.R
\name{k_centroids}
\alias{k_centroids}
\title{Function to calculate the centroids of different groups (classes)}
\usage{
k_centroids(data, class)
}
\arguments{
\item{data}{a scaled gene expression \code{matrix} or \code{data.frame} 
with samples as columns and features as rows}

\item{class}{a vector with the samples classes}
}
\value{
returns a \code{data.frame} with the estimated prototypic centroids 
for each class with the features names as rownames
}
\description{
This function calculates the mean value for each feature of each class to 
calculate the prototypic centroids of the different groups
}
\examples{
# load example dataset
require(iC10TrainingData)
require(pamr)

data(train.Exp)

calculate_distance <- select_distance(distancetype = "pearson")
Dist <- calculate_distance(train.Exp)
k <- 4
Pam <- cluster_algorithm(Dist, k)
table(Pam$cluster)
centroids <- k_centroids(train.Exp, Pam)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/results-functions.R
\name{non_dominated_summary}
\alias{non_dominated_summary}
\title{Summary of the non dominated solutions}
\usage{
non_dominated_summary (output, prob_matrix, OS,
distancetype = "pearson")
}
\arguments{
\item{output}{An object of class \code{galgo.Obj}}

\item{prob_matrix}{a \code{matrix} or \code{data.frame}. Must be an
expression matrix with features in rows and samples in columns}

\item{OS}{a \code{survival} object (see \code{\link[survival]{Surv}}
function from the \code{\link{survival}} package)}

\item{distancetype}{a \code{character} that can be either \code{'pearson'},
\code{'uncentered'}, \code{'spearman'} or \code{'euclidean'}}
}
\value{
Returns a \code{data.frame} with 5 columns and a number of rows
equals to the non-dominated solutions found by GalgoR.
The first column has the name of the non-dominated solutions, the second
the number of partitions found for each solution \code{(k)}, the third,
the number of genes, the fourth the mean silhouette coefficient of the
solution and the last columns has the estimated C.Index for each one.
}
\description{
The function uses a \code{'galgo.Obj'} as input an the training dataset to
evaluate the non-dominated solutions found by GalgoR
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15,
prob_matrix = expression, OS = OS)
non_dominated_summary(
    output = output,
    OS = OS,
    prob_matrix = expression,
    distancetype = "pearson"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster-classifier.R
\name{cosine_similarity}
\alias{cosine_similarity}
\title{Function for calculating the cosine similarity}
\usage{
cosine_similarity(a, b)
}
\arguments{
\item{a, b}{A string of numbers with equal length. It can also be two 
binary strings of 0's and 1's}
}
\value{
In practice, the function can return numeric values from -1 to 1 
according the vector orientations, where a cosine similarity of 1 implies 
same orientation of the vectors while -1 imply vector of opposing directions.
In the binary application, values range from 0 to 1, where 0 are totally 
discordant vectors while 1 are identical binary vectors.
}
\description{
Cosine similarity is a metric of similarity between two non-zero vectors 
of an inner product space that measures the cosine of the angle between them.
Two vectors with the same orientation have a cosine similarity of 1, if 
they are perpendicular they have a similarity of 0, and if they have 
opposing directions the cosine similarity is -1, independent of their
magnitude.
One advantage of cosine similarity is its low-complexity, especially for 
sparse vectors where only the non-zero dimensions need to be considered, 
which is a common case in \code{GSgalgoR}.
Other names of cosine similarity are Otuska-Orchini similarity when it is 
applied to binary data, which is the case for \code{GSgalgoR}, where 
individual solutions represented as strings of 0 and 1 are compared with t
his metric.
}
\examples{
solution1 <- c(1, 0, 0, 1, 0, 0, 1)
solution2 <- solution1
r <- cosine_similarity(solution1, solution2)
# the cosine similarity (r) equals 1
solution2 <- abs(solution1 - 1)
r2 <- cosine_similarity(solution1, solution2)
# the cosine similarity (r2) equals 0
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert-functions.R
\name{to_list}
\alias{to_list}
\title{Convert galgo.Obj to list}
\usage{
to_list(output)
}
\arguments{
\item{output}{An object of class \code{galgo.Obj}}
}
\value{
The current function restructurates a \code{galgo.Obj} to a more 
easy to understand an use \code{list}. This output is particularly useful 
if one wants to select a given solution and use its outputs in a new 
classifier. The output of type \code{list} has a length equals to the 
number of solutions obtained by the \code{\link[GSgalgoR:galgo]{galgo}} 
algorithm.

Basically this output is a list of lists, where each element of the output 
is named after the solution's name (\code{solution.n}, where \code{n} is 
the number assigned to that solution), and inside of it, it has all the 
constituents for that given solution with the following structure:
\enumerate{
\item \strong{output$solution.n$Genes}: A vector of the features included 
in the solution
\item \strong{output$solution.n$k}: The number of partitions found in that 
solution
\item \strong{output$solution.n$SC.Fit}: The average silhouette coefficient 
of the partitions found
\item \strong{output$solution.n$Surv.Fit}: The survival fitness value
\item \strong{output$solution.n$Rank}: The solution rank
\item \strong{CrowD}: The solution crowding distance related to the rest 
of the solutions
}
}
\description{
The current function transforms a \code{galgo.Obj} to a \code{list}
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15, 
prob_matrix = expression, OS = OS)
outputDF <- to_dataframe(output)
outputList <- to_list(output)
}
\author{
Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/results-functions.R
\name{create_centroids}
\alias{create_centroids}
\title{Create Centroids}
\usage{
create_centroids (output, solution_names, trainset,
distancetype = "pearson")
}
\arguments{
\item{output}{@param output An object of class \code{galgo.Obj}}

\item{solution_names}{A \code{character} vector with the names of the
solutions for which the centroids are to be calculated}

\item{trainset}{a \code{matrix} or \code{data.frame}. Must be an expression
matrix with features in rows and samples in columns}

\item{distancetype}{a \code{character} that can be either \code{'pearson'},
\code{'uncentered'}, \code{'spearman'} or \code{'euclidean'}}
}
\value{
Returns a list with the centroid matrix for each of the solutions
in \code{solution_names}, where each column represents the prototypic
centroid of a subtype and each row the constituents features of the
solution signature
}
\description{
This functions create the signature centroids estimated from the
GalgoR output and the expression matrix of the training sets.
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15,
prob_matrix = expression, OS = OS)
outputDF <- to_dataframe(output)
outputList <- to_list(output)

RESULTS <- non_dominated_summary(
    output = output, OS = OS,
    prob_matrix = expression,
    distancetype = "pearson"
)
CentroidsList <- create_centroids(output, RESULTS$solution,
trainset = expression)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/galgo.R
\docType{class}
\name{galgo.Obj-class}
\alias{galgo.Obj-class}
\alias{galgo.Obj}
\title{Galgo Object class}
\description{
Galgo Object class
}
\section{Slots}{

\describe{
\item{\code{Solutions}}{matrix.}

\item{\code{ParetoFront}}{list.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/callback-functions.R
\name{callback_base_return_pop}
\alias{callback_base_return_pop}
\title{A base callback function that returns a galgo.Obj}
\usage{
callback_base_return_pop (userdir = "",generation, pop_pool, 
pareto, prob_matrix, current_time)
}
\arguments{
\item{userdir}{the default directory used by `galgo()` to store files}

\item{generation}{a number indicating the number of iterations of the galgo 
algorithm}

\item{pop_pool}{a \code{data.frame} with the solution vectors, number of 
clusters and their ranking.}

\item{pareto}{the solutions found by Galgo across all generations in the 
solution space}

\item{prob_matrix}{a \code{matrix} or \code{data.frame}. Must be an 
expression matrix with features in rows and samples in columns}

\item{current_time}{an \code{POSIXct} object}
}
\value{
an object of class galgo
}
\description{
A base callback function that returns a galgo.Obj
}
\examples{
# load example dataset

library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)
expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo with base_return_pop_callback assigned to the end_galgo_callback
# hook-point
# By using this callback galgo() return a `galgo,Obj` object.
output <- GSgalgoR::galgo(generations = 5,
population = 15,
prob_matrix = expression,
OS = OS,
end_galgo_callback = callback_base_return_pop
)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert-functions.R
\name{to_dataframe}
\alias{to_dataframe}
\title{Convert galgo.Obj to data.frame}
\usage{
to_dataframe(output)
}
\arguments{
\item{output}{An object of class \code{galgo.Obj}}
}
\value{
The current function restructurates a \code{galgo.Obj} to a more 
easy to understand an use \code{data.frame}. The output \code{data.frame} 
has \eqn{ m x n} dimensions, were the rownames (\eqn{m}) are the solutions 
obtained by the \code{\link[GSgalgoR:galgo]{galgo}} algorithm. 
The columns has the following structure:
\enumerate{
\item \strong{Genes}: The features included in each solution in form 
of a \code{list}
\item \strong{k}: The number of partitions found in that solution
\item \strong{SC.Fit}: The average silhouette coefficient of the 
partitions found
\item \strong{Surv.Fit}: The survival fitness value
\item \strong{Rank}: The solution rank
\item \strong{CrowD}: The solution crowding distance related to the 
rest of the solutions
}
}
\description{
The current function transforms a \code{galgo.Obj} to a \code{data.frame}
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15, 
prob_matrix = expression, OS = OS)
outputDF <- to_dataframe(output)
outputList <- to_list(output)
}
\author{
Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/callback-functions.R
\name{callback_default}
\alias{callback_default}
\title{A default call_back function that does nothing.}
\usage{
callback_default (userdir = "",generation, pop_pool, 
pareto, prob_matrix, current_time)
}
\arguments{
\item{userdir}{the default directory used by \code{galgo()} to store files}

\item{generation}{a number indicating the number of iterations of the 
galgo algorithm}

\item{pop_pool}{a \code{data.frame} with the solution vectors, number 
of clusters and their ranking.}

\item{pareto}{the solutions found by Galgo across all generations in 
the solution space}

\item{prob_matrix}{a \code{matrix} or \code{data.frame}. Must be an 
expression matrix with features in rows and samples in columns}

\item{current_time}{an \code{POSIXct} object}
}
\value{
Nothing
}
\description{
A default call_back function that does nothing.
}
\examples{
# load example dataset

library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)
expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)
# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo with default_callback assigned to all the hook-points

GSgalgoR::galgo(generations = 5,
population = 15,
prob_matrix = expression,
OS = OS,
start_galgo_callback = callback_default,# When Galgo is about to start.
end_galgo_callback = callback_default,  # When Galgo is about to finish.
start_gen_callback = callback_default,  # At the beginning of each iteration.
end_gen_callback = callback_default,    # At the end of each iteration.
)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distance-functions.R
\name{calculate_distance}
\alias{calculate_distance}
\alias{calculate_distance_pearson_cpu}
\alias{calculate_distance_spearman_cpu}
\alias{calculate_distance_uncentered_cpu}
\alias{calculate_distance_euclidean_cpu}
\alias{select_distance}
\title{Functions to calculate distance matrices using cpu computing}
\usage{
calculate_distance_pearson_cpu(x)

calculate_distance_spearman_cpu(x)

calculate_distance_uncentered_cpu(x)

calculate_distance_euclidean_cpu(x)

select_distance(distancetype = "pearson")
}
\arguments{
\item{x}{an expression matrix with features as rows and samples as columns}

\item{distancetype}{a \code{character} that can be either \code{'pearson'}, 
\code{'uncentered'}, \code{'spearman'} or \code{'euclidean'}}
}
\value{
\code{select_distance(distancetype)} assigns global function 
calculate_distance according to the parameters specified

\code{calculate_distance_pearson_cpu(x)} returns columnwise pearson 
distance calculated using the CPU

\code{calculate_distance_uncentered_cpu(x)} returns columnwise 
uncentered pearson distance calculated using the CPU

\code{calculate_distance_spearman_cpu(x)} returns columnwise 
spearman distance calculated using the CPU

\code{calculate_distance_euclidean_cpu(x)} returns columnwise 
euclidean distance calculated using the CPU
}
\description{
Functions to calculate distance matrices using cpu computing
}
\examples{
# load example dataset
require(iC10TrainingData)
require(pamr)

data(train.Exp)

calculate_distance <- select_distance(distancetype = "pearson")
Dist <- calculate_distance(train.Exp)
k <- 4
Pam <- cluster_algorithm(Dist, k)
table(Pam$cluster)
}
\author{
Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/galgo.R
\docType{package}
\name{GSgalgoR-package}
\alias{GSgalgoR-package}
\alias{GSgalgoR}
\title{GSgalgoR:  A bi-objective evolutionary meta-heuristic to identify
robust transcriptomic classifiers associated with patient outcome across
multiple cancer types.}
\description{
This package was developed to provide a simple to use set of
functions to use the galgo algorithm. A multi-objective optimization
algorithm for disease subtype discovery based on a non-dominated sorting
genetic algorithm.

Different statistical and machine learning approaches have long been
used to identify gene expression/molecular signatures with prognostic
potential in different cancer types. Nonetheless, the molecular
classification of tumors is a difficult task and the results obtained
via the current statistical methods are highly dependent on the features
analyzed, the number of possible tumor subtypes under consideration, and
the underlying assumptions made about the data. In addition, some cancer
types are still lacking prognostic signatures and/or of subtype-specific
predictors which are continually needed to further dissect tumor biology.
In order to identify specific molecular phenotypes to develop precision
medicine strategies we present Galgo: A multi-objective optimization
process based on a non-dominated sorting genetic algorithm that combines
the advantages of clustering methods for grouping heterogeneous omics data
and the exploratory properties of genetic algorithms (GA) in order to find
features that maximize the survival difference between subtypes while
keeping high cluster consistency.

\tabular{ll}{ Package: \tab GSgalgoR\cr Type: \tab Package\cr
Version: \tab 1.0.0\cr Date: \tab 2020-05-06 \cr License: \tab GPL-3\cr
Copyright: \tab (c) 2020 Martin E. Guerrero-Gimenez.\cr URL: \tab
\url{https://www.github.com/harpomaxx/galgo}\cr LazyLoad: \tab yes\cr
}
}
\author{
Martin E. Guerrero-Gimenez \email{mguerrero@mendoza-conicet.gob.ar}

Maintainer: Carlos A. Catania \email{harpomaxx@gmail.com }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/galgo.R
\name{surv_fitness}
\alias{surv_fitness}
\title{Survival fitness function using the Restricted Mean Survival Time (RMST)
of each group}
\usage{
surv_fitness(OS, clustclass, period)
}
\arguments{
\item{OS}{a \code{survival} object with survival data of the patients
evaluated}

\item{clustclass}{a numeric vector with the group label for each patient}

\item{period}{a number representing the period of time to evaluate in the
RMST calculation}
}
\value{
The function computes the Harmonic mean of the differences
between Restricted Mean Survival Time (RMST) of consecutive survival
curves multiplied by the number of comparisons.
}
\description{
Survival fitness function using the Restricted Mean Survival Time (RMST)
of each group as proposed by \emph{Dehbi & Royston et al. (2017)}.
}
\examples{

# load example dataset
library(breastCancerTRANSBIG)
library(Biobase)
data(transbig)
Train <- transbig
rm(transbig)

clinical <- pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

surv_fitness(OS, clustclass = clinical$grade, period = 3650)
}
\references{
Dehbi Hakim-Moulay, Royston Patrick, Hackshaw Allan. Life
expectancy difference and life expectancy ratio: two measures of treatment
effects in randomized trials with non-proportional
hazards BMJ 2017; 357 :j2250 \url{https://www.bmj.com/content/357/bmj.j2250}
}
\author{
Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/results-functions.R
\name{classify_multiple}
\alias{classify_multiple}
\title{Classify samples from multiple centroids}
\usage{
classify_multiple(prob_matrix, centroid_list, distancetype = "pearson")
}
\arguments{
\item{prob_matrix}{a \code{matrix} or \code{data.frame}. Must be an
expression matrix with features in rows and samples in columns}

\item{centroid_list}{a\code{list} with the centroid matrix for each of
the signatures to evaluate, where each column represents the prototypic
centroid of a subtype and each row the constituents features of the
solution signature. The output of
\code{\link[GSgalgoR:create_centroids]{create_centroids}} can be used.}

\item{distancetype}{a \code{character} that can be either
\code{'pearson'} (default), \code{'spearman'} or \code{'kendall'}.}
}
\value{
Returns a \code{data.frame} with the classes assigned to
each sample in each signature, were samples are a rows and signatures
in columns
}
\description{
Classify samples from multiple centroids
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15,
prob_matrix = expression, OS = OS)
outputDF <- to_dataframe(output)
outputList <- to_list(output)

RESULTS <- non_dominated_summary(
    output = output, OS = OS,
    prob_matrix = expression,
    distancetype = "pearson"
)
CentroidsList <- create_centroids(output, RESULTS$solution,
trainset = expression)
classes <- classify_multiple(prob_matrix = expression,
centroid_list = CentroidsList)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster-classifier.R
\name{cluster_classify}
\alias{cluster_classify}
\title{Distance to centroid classifier function}
\usage{
cluster_classify(data, centroid, method = "pearson")
}
\arguments{
\item{data}{a \code{data.frame} of dimensions \eqn{n x p} with the samples 
to classify, were \eqn{n} are the same set of features as in the centroids}

\item{centroid}{a \code{data.frame} of dimensions \eqn{n x m}, where each 
column is a prototypic centroid to classify the samples}

\item{method}{Character string indicating which method to use to calculate 
distance to centroid. Options are \code{"pearson"} (default), 
\code{"kendall"}, or \code{"spearman"}}
}
\value{
Returns a numeric vector of length \eqn{p} with the class assigned 
to each sample according to the shortest distance to centroid
}
\description{
Given an \eqn{n x m} matrix of centroids, where \eqn{m} are the prototypic 
centroids with \eqn{n} features, classify new samples according to the 
distance to the centroids.
}
\examples{

# load example dataset
require(iC10TrainingData)
require(pamr)

data(train.Exp)
data(IntClustMemb)
TrainData <- list(x = train.Exp, y = IntClustMemb)

# Create prototypic centroids
pam <- pamr.train(TrainData)
centroids <- pam$centroids

Class <- cluster_classify(train.Exp, centroids)
table(Class, IntClustMemb)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster-classifier.R
\name{cluster_algorithm}
\alias{cluster_algorithm}
\title{Wrapper function to perform partition around medioids (PAM) for GalgoR}
\usage{
cluster_algorithm(c, k)
}
\arguments{
\item{c}{a dissimilarity matrix object of type \code{'dist'}}

\item{k}{positive integer specifying the number of clusters, less than the 
number of observations}
}
\value{
Returns a \code{'list'} with the value \code{'$cluster'} which 
contains the cluster assignment of each of the samples evaluated
}
\description{
In \code{GSgalgoR}, the partition around medioids (PAM) algorithm is the 
default clustering process used under the evolutionary process.
}
\details{
The function runs the \code{\link[cluster:pam]{pam}} function of 
the \code{'cluster'} package 
with options \code{cluster.only =TRUE}, 
\code{diss = TRUE}, \code{do.swap=TRUE}, 
\code{keep.diss=FALSE}, \code{keep.data = FALSE}, 
\code{pamonce= 2}
}
\examples{
# load example dataset
require(iC10TrainingData)
require(pamr)
data(train.Exp)

calculate_distance <- select_distance(distancetype = "pearson")
Dist <- calculate_distance(train.Exp)
k <- 4
Pam <- cluster_algorithm(Dist, k)
table(Pam$cluster)
}
\references{
\itemize{
\item Reynolds, A., Richards, G., de la Iglesia, B. and Rayward-Smith, V. 
(1992) Clustering rules: A comparison of partitioning and 
hierarchical clustering algorithms; Journal of Mathematical Modelling and 
Algorithms 5, 475--504. 10.1007/s10852-005-9022-1.
\item Erich Schubert and Peter J. Rousseeuw (2019) Faster k-Medoids 
Clustering: Improving the PAM, CLARA, and CLARANS Algorithms; Preprint, 
(\url{https://arxiv.org/abs/1810.05691}).
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-functions.R
\name{plot_pareto}
\alias{plot_pareto}
\title{Plot pareto front from an galgo.Obj}
\usage{
plot_pareto(output)
}
\arguments{
\item{output}{An object of class \code{galgo.Obj}}
}
\value{
This function returns a scatterplot showing the solutions found by 
Galgo accross all generations in the solution space, where the Silhouette 
Fitness is in the x-axis and the survival fitness in the y-axis.
A line is drawn over all non-dominated solutions showing the estimated 
Pareto front
}
\description{
Plot pareto front from an galgo.Obj
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(1:nrow(expression), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15, 
prob_matrix = expression, OS = OS)
plot_pareto(output)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/galgo.R
\name{galgo}
\alias{galgo}
\title{GSgalgoR main function}
\usage{
galgo (population = 30, generations = 2, nCV = 5,
distancetype = "pearson", TournamentSize = 2, period = 1825,
OS, prob_matrix, res_dir = "", start_galgo_callback = callback_default,
end_galgo_callback = callback_base_return_pop,
report_callback = callback_base_report,
start_gen_callback = callback_default,
end_gen_callback = callback_default,
verbose = 2)
}
\arguments{
\item{population}{a number indicating the number of solutions in the
population of solutions that will be evolved}

\item{generations}{a number indicating the number of iterations of the
galgo algorithm}

\item{nCV}{number of cross-validation sets}

\item{distancetype}{character, it can be
\code{'pearson'} (centered pearson), \code{'uncentered'}
(uncentered pearson), \code{'spearman'} or \code{'euclidean'}}

\item{TournamentSize}{a number indicating the size of the tournaments for
the selection procedure}

\item{period}{a number indicating the outcome period to evaluate the RMST}

\item{OS}{a \code{survival} object (see \code{ \link[survival]{Surv} }
function from the \code{\link{survival}} package)}

\item{prob_matrix}{a \code{matrix} or \code{data.frame}. Must be an
expression matrix with features in rows and samples in columns}

\item{res_dir}{a \code{character} string indicating where to save the
intermediate and final output of the algorithm}

\item{start_galgo_callback}{optional callback function for the start
of the galgo execution}

\item{end_galgo_callback}{optional callback function for the end of the
galgo execution}

\item{report_callback}{optional callback function}

\item{start_gen_callback}{optional callback function for the beginning
of the run}

\item{end_gen_callback}{optional callback function for the end of the run}

\item{verbose}{select the level of information printed during galgo
execution}
}
\value{
an object of type \code{'galgo.Obj'} that corresponds to a list
with the elements \code{$Solutions} and \code{$ParetoFront}.
\code{$Solutions} is a \eqn{l x (n + 5)} matrix where \eqn{n} is the number
of features evaluated and \eqn{l} is the number of solutions obtained.
The submatrix \eqn{l x n} is a binary matrix where each row represents
the chromosome of an evolved solution from the solution population, where
each feature can be present (1) or absent (0) in the solution.
Column \eqn{n +1} represent the  \eqn{k} number of clusters for each
solutions. Column \eqn{n+2} to \eqn{n+5} shows the SC Fitness and
Survival Fitness values, the solution rank, and the crowding distance of
the solution in the final pareto front respectively.
For easier interpretation of the \code{'galgo.Obj'}, the output can be
reshaped using the \code{\link[GSgalgoR:to_list]{to_list}} and
\code{\link[GSgalgoR:to_dataframe]{to_dataframe}} functions
}
\description{
\code{\link[GSgalgoR:galgo]{galgo}} accepts an expression matrix and a
survival object to find robust gene expression signatures related to a
given outcome
}
\examples{
# load example dataset
library(breastCancerTRANSBIG)
data(transbig)
Train <- transbig
rm(transbig)

expression <- Biobase::exprs(Train)
clinical <- Biobase::pData(Train)
OS <- survival::Surv(time = clinical$t.rfs, event = clinical$e.rfs)

# We will use a reduced dataset for the example
expression <- expression[sample(seq_len(nrow(expression)), 100), ]

# Now we scale the expression matrix
expression <- t(scale(t(expression)))

# Run galgo
output <- GSgalgoR::galgo(generations = 5, population = 15,
prob_matrix = expression, OS = OS)
outputDF <- to_dataframe(output)
outputList <- to_list(output)
}
\author{
Martin E Guerrero-Gimenez, \email{mguerrero@mendoza-conicet.gob.ar}
}
